-- **************************************************************************
-- * Multi Raid Alert 0.4
-- * by evil.oz
-- *
-- *************************************************************************

BINDING_HEADER_MultiRaidAlertCFG = "Multi Raid Alert";
BINDING_NAME_MultiRaidAlertButton1 = "Button n. 1";
BINDING_NAME_MultiRaidAlertButton2 = "Button n. 2";
BINDING_NAME_MultiRaidAlertButton3 = "Button n. 3";
BINDING_NAME_MultiRaidAlertButton4 = "Button n. 4";
BINDING_NAME_MultiRaidAlertButton5 = "Button n. 5";
BINDING_NAME_MultiRaidAlertButton6 = "Button n. 6";
BINDING_NAME_MultiRaidAlertButton7 = "Button n. 7";
BINDING_NAME_MultiRaidAlertButton8 = "Button n. 8";
BINDING_NAME_MultiRaidAlertButton9 = "Button n. 9";
BINDING_NAME_MultiRaidAlertButton10 = "Button n. 10";
BINDING_NAME_MultiRaidAlertButton11 = "Button n. 11";
BINDING_NAME_MultiRaidAlertButton12 = "Button n. 12";
BINDING_NAME_MultiRaidAlertToggle = "Show / Hide Multi Raid Alert";
MRA_ButtonSpacing=18
MRA_ButtonSpacer=8
MRA_ConfigButtonSpacing=18
CHANNELCHOICE={[1]="SAY",[2]="RAID",[3]="CTRAID",[4]="RAID_WARNING",[5]="PARTY",[6]="GUILD",[7]="CHANNEL"}
CHANNELNUM_TOOLTIP="channel number (1-10)"

MRAMAX_BUTTONS=12

-- *************************************************************************
-- INITIALIZATION
-- *************************************************************************
function MultiRaidAlert_OnLoad() 

	this:RegisterEvent("VARIABLES_LOADED");
        this:RegisterForDrag("LeftButton");



	-- add the slash commands
	SlashCmdList["MRACMD"] = function(msg)
		MultiRaidAlert_cmd(msg);
	end
	SLASH_MRACMD1 = "/mra";
	SLASH_MRACMD2 = "/multiraidalert";


end

function MultiRaidAlertConfig_OnLoad() 

	MRAPrintout("config onload")
        this:RegisterForDrag("LeftButton");

end

-- *************************************************************************
-- EVENT HANDLER (init after var loads for now)
-- *************************************************************************
function MultiRaidAlert_OnEvent(event)

	if (event == "VARIABLES_LOADED") then
	        MRAPrintout("MultiRaidAlert 0.4 by evil.oz", 1.0, 1.0, 0.0);
		InitVars()

		if MultiRaidAlertOptions["Visible"] then
			MultiRaidAlertFrame:Show()
		else
			MultiRaidAlertFrame:Hide()	
			MRAPrintout("pannel is hidden, type /mra or /multiraidalert to enable it", 1.0, 1.0, 0.0);
		end

		UpdateGrid()
	end
end


-- *************************************************************************
-- WHEN BUTTON PRESSED
-- *************************************************************************
function MultiRaidAlert_Button(arg)

	--MRAPrintout(arg)
	local text, mode

	text=MultiRaidAlertData[MultiRaidAlertOptions["LastSet"]]["MSG"][arg][2]
	text=MultiRaidAlertData[MultiRaidAlertOptions["LastSet"]]["LEFTBRACKETS"].." "..text.." "..MultiRaidAlertData[MultiRaidAlertOptions["LastSet"]]["RIGHTBRACKETS"]


	if MultiRaidAlertData[MultiRaidAlertOptions["LastSet"]]["MSG"][arg][4] then
		mode=MultiRaidAlertData[MultiRaidAlertOptions["LastSet"]]["MSG"][arg][4]
	else
		mode="RAID_WARNING"
	end


	if mode=="RAID_WARNING" then
		SendChatMessage(text,"RAID_WARNING");
	end
	if mode=="CHANNEL" then
		chan=MultiRaidAlertData[MultiRaidAlertOptions["LastSet"]]["MSG"][arg][5]
		SendChatMessage(text,"CHANNEL", nil,chan);
	end
	if mode=="GUILD" then
		SendChatMessage(text,"GUILD");
	end
	if mode=="RAID" then
		SendChatMessage(text,"RAID");
	end
	if mode=="PARTY" then
		SendChatMessage(text,"PARTY");
	end
	if mode=="SAY" then
		SendChatMessage(text,"SAY");
	end
	if mode=="CTRAID" then
	
		if ( GetNumRaidMembers() ~= 0 ) then 
			msg= "MS "..text
			SendAddonMessage("CTRA", msg, "RAID");
		end
		SendChatMessage(text,"RAID");
	end
	



end


-- *************************************************************************
-- REDRAW CONFIG FRAME
-- *************************************************************************
function UpdateConfigGrid()

	local LastSet=MultiRaidAlertOptions["LastSet"]


	if not(MultiRaidAlertData[LastSet]) then
		for n=1,table.getn(MultiRaidAlertData) do
			if MultiRaidAlertData[n] then
				MultiRaidAlertOptions["LastSet"]=n
				LastSet=n
				do break end
			end
		end
	end


	local buttons=table.getn(MultiRaidAlertData[LastSet]["MSG"])


	
	getglobal("MRASetName"):SetText(MultiRaidAlertData[LastSet]["NAME"])
	getglobal("MRALeftBrackets"):SetText(MultiRaidAlertData[LastSet]["LEFTBRACKETS"])
	getglobal("MRARightBrackets"):SetText(MultiRaidAlertData[LastSet]["RIGHTBRACKETS"])

	
	for button=1, buttons do
		getglobal("MRAButtonCaption"..button):Show()
		getglobal("MRAButtonString"..button):Show()
		getglobal("MRAButtonChannel"..button):Show()
		getglobal("MRAButtonChannelNum"..button):Show()
		
		--spacing not allowed on combo-buttons
		if (button ~=2) and (button ~=4) and (button ~=5) then 
			getglobal("MRAButtonCheckSpacing"..button):Show()	
		else
			getglobal("MRAButtonCheckSpacing"..button):Hide()		
		end

		off=6+button*MRA_ConfigButtonSpacing
		getglobal("MRAButtonCaption"..button):ClearAllPoints()
		getglobal("MRAButtonCaption"..button):SetPoint("TOPLEFT" , "MultiRaidAlertLabel1" , "TOPLEFT" , 0, -off) 
		getglobal("MRAButtonString"..button):ClearAllPoints()
		getglobal("MRAButtonString"..button):SetPoint("TOPLEFT" , "MultiRaidAlertLabel2" , "TOPLEFT" , 0, -off) 
		getglobal("MRAButtonChannel"..button):ClearAllPoints()
		getglobal("MRAButtonChannel"..button):SetPoint("TOPLEFT" , "MultiRaidAlertLabel3" , "TOPLEFT" , 0, -off+4) 
		getglobal("MRAButtonChannelNum"..button):ClearAllPoints()
		getglobal("MRAButtonChannelNum"..button):SetPoint("TOPLEFT" , "MultiRaidAlertLabel4" , "TOPLEFT" , 0, -off) 
		getglobal("MRAButtonCheckSpacing"..button):ClearAllPoints()
		getglobal("MRAButtonCheckSpacing"..button):SetPoint("TOPLEFT" , "MultiRaidAlertLabel5" , "TOPLEFT" , 0, -off+5) 

		getglobal("MRAButtonCaption"..button):SetText(MultiRaidAlertData[LastSet]["MSG"][button][1])
		getglobal("MRAButtonString"..button):SetText(MultiRaidAlertData[LastSet]["MSG"][button][2])
		getglobal("MRAButtonChannel"..button):SetText(MultiRaidAlertData[LastSet]["MSG"][button][4])
		getglobal("MRAButtonChannelNum"..button):SetText(MultiRaidAlertData[LastSet]["MSG"][button][5])
		getglobal("MRAButtonCheckSpacing"..button):SetChecked(MultiRaidAlertData[LastSet]["MSG"][button][3])

		if getglobal("MRAButtonChannel"..button):GetText()=="CHANNEL" then
			getglobal("MRAButtonChannelNum"..button):Show()
		else
			getglobal("MRAButtonChannelNum"..button):Hide()
		end

		
		if (buttons==1) then
			getglobal("MRAConfigMinus"..button):Hide()
		else
			getglobal("MRAConfigMinus"..button):Show()
		end
		
		if (button ~= MRAMAX_BUTTONS) then 
			if (buttons ~= MRAMAX_BUTTONS) then
				getglobal("MRAConfigPlus"..button):Show()
			else
				getglobal("MRAConfigPlus"..button):Hide()	
			end
		end


		if (MultiRaidAlertData[LastSet]["MSG"][button][1]=="") then
			getglobal("MRAButtonChannel"..button):Disable()
			getglobal("MRAButtonCheckSpacing"..button):Disable()

		else
			getglobal("MRAButtonChannel"..button):Enable()
			getglobal("MRAButtonCheckSpacing"..button):Enable()
		end
	end

	if (buttons ~= MRAMAX_BUTTONS) then
		getglobal("MRAConfigPlus0"):Show()
	else
		getglobal("MRAConfigPlus0"):Hide()	
	end


	--and hide others
	for button=buttons+1,MRAMAX_BUTTONS do
		getglobal("MRAButtonCaption"..button):Hide()
		getglobal("MRAButtonString"..button):Hide()
		getglobal("MRAButtonChannel"..button):Hide()
		getglobal("MRAButtonChannelNum"..button):Hide()
		getglobal("MRAButtonCheckSpacing"..button):Hide()	
		getglobal("MRAConfigMinus"..button):Hide()
		if button ~= MRAMAX_BUTTONS then
			getglobal("MRAConfigPlus"..button):Hide()	
		end
	end

	if buttons > 0 then
		getglobal("MRAButtonCheckSpacing"..table.getn(MultiRaidAlertData[LastSet]["MSG"])):Hide()		
	end

	MultiRaidAlertConfigFrame:SetHeight(buttons*20+120)
	
end

-- *************************************************************************
-- pressed "-"
-- *************************************************************************
function MRAConfigRemoveButton(arg)

	local LastSet=MultiRaidAlertOptions["LastSet"]

	if table.getn(MultiRaidAlertData[LastSet]["MSG"])>1 then

		table.remove(MultiRaidAlertData[LastSet]["MSG"],arg)
		UpdateConfigGrid()
		UpdateGrid()
	end

end


-- *************************************************************************
-- pressed "+"
-- *************************************************************************
function MRAConfigAddButton(arg)

	local LastSet=MultiRaidAlertOptions["LastSet"]

	if table.getn(MultiRaidAlertData[LastSet]["MSG"])<MRAMAX_BUTTONS then

		new={"LABEL","TEXT", false , "RAID", 0}
					
		table.insert(MultiRaidAlertData[LastSet]["MSG"], arg+1, new)
		UpdateConfigGrid()
		UpdateGrid()
	end

end


-- *************************************************************************
-- "REMOVE SET" PRESSED
-- *************************************************************************
function MRARemoveSet()

	local LastSet=MultiRaidAlertOptions["LastSet"]


	if table.getn(MultiRaidAlertData)>1 then

		table.remove(MultiRaidAlertData,LastSet)
		UpdateConfigGrid()
		UpdateGrid()
	end	
	
end

-- *************************************************************************
-- "NEW SET" PRESSED
-- *************************************************************************
function MRAAddSet()

	local new
	local LastSet=MultiRaidAlertOptions["LastSet"]

	new={	["NAME"]="SET n."..random(1000,9999),
                ["MSG"] = {	{"B1","text1", false , "RAID", 0},
				{"B2","text2", false , "RAID", 0}
			},
		["LEFTBRACKETS"]=">-",["RIGHTBRACKETS"]="-<"
	    }
					
	table.insert(MultiRaidAlertData, LastSet, new)

	new={}		

	UpdateConfigGrid()
	UpdateGrid()
	
	
	
end

-- *************************************************************************
-- SET HAS BEN RENAMED
-- *************************************************************************
function MRASetNameChanged()

	local LastSet=MultiRaidAlertOptions["LastSet"]

	MultiRaidAlertData[LastSet]["NAME"]=getglobal("MRASetName"):GetText()
	UpdateGrid()

end

-- *************************************************************************
-- BRACKETS HAS BEEN UPDATED
-- *************************************************************************
function MRASetBracketsChanged()

	local LastSet=MultiRaidAlertOptions["LastSet"]
	
	MultiRaidAlertData[LastSet]["LEFTBRACKETS"]=getglobal("MRALeftBrackets"):GetText()
	MultiRaidAlertData[LastSet]["RIGHTBRACKETS"]=getglobal("MRARightBrackets"):GetText()

end

-- *************************************************************************
-- update button row
-- *************************************************************************
function MRAButtonCaptionUpdate(button)

	--MRAPrintout(button)

	local LastSet=MultiRaidAlertOptions["LastSet"]

	if MultiRaidAlertData[LastSet]["MSG"][button] then

		MultiRaidAlertData[LastSet]["MSG"][button][1]=getglobal("MRAButtonCaption"..button):GetText()
		MultiRaidAlertData[LastSet]["MSG"][button][2]=getglobal("MRAButtonString"..button):GetText()
		MultiRaidAlertData[LastSet]["MSG"][button][4]=getglobal("MRAButtonChannel"..button):GetText()
		MultiRaidAlertData[LastSet]["MSG"][button][5]=getglobal("MRAButtonChannelNum"..button):GetText()
		MultiRaidAlertData[LastSet]["MSG"][button][3]=getglobal("MRAButtonCheckSpacing"..button):GetChecked()


		if (MultiRaidAlertData[LastSet]["MSG"][button][1]=="") then
			getglobal("MRAButtonChannel"..button):Disable()
			getglobal("MRAButtonCheckSpacing"..button):Disable()

		else
			getglobal("MRAButtonChannel"..button):Enable()
			getglobal("MRAButtonCheckSpacing"..button):Enable()
		end
		
		UpdateGrid()

	end

end

function MRAButtonChannelButton(button)

	local k,x,y,text
	local LastSet=MultiRaidAlertOptions["LastSet"]
	local label=getglobal("MRAButtonChannel"..button):GetText()
	local found=false
	local shift=IsShiftKeyDown()
	

	for n=1,6 do
		if (CHANNELCHOICE[n]==label) then
			found=true
			if n==6 then
				k=1
			else
				k=n+1
			end

			text=CHANNELCHOICE[k]

			if shift then
				x=1
				y=table.getn(MultiRaidAlertData[LastSet]["MSG"])
			else
				x=button
				y=button
			end

			for but=x,y do
				getglobal("MRAButtonChannel"..but):SetText(text)
				MultiRaidAlertData[LastSet]["MSG"][but][4]=text

				if text=="CHANNEL" then
					getglobal("MRAButtonChannelNum"..but):Show()
				else
	 				getglobal("MRAButtonChannelNum"..but):Hide()
				end
			end
			
		end
	end

	if not found then
		text="SAY"
		getglobal("MRAButtonChannel"..button):SetText(text)
		MultiRaidAlertData[LastSet]["MSG"][button][4]=text

		if text=="CHANNEL" then
			getglobal("MRAButtonChannelNum"..button):Show()
		else
			getglobal("MRAButtonChannelNum"..button):Hide()
		end
	end


end

-- *************************************************************************
-- click on frame (not buttons)
-- *************************************************************************
function MultiRaidAlert_Click()

	if IsShiftKeyDown() then
		MultiRaidAlertConfigFrame:Show()

		MRAPrintout("Multi Raid Alert config panel is now VISIBLE")	
		UpdateConfigGrid()
	end
		
end

-- *************************************************************************
-- REDRAW BUTTON ARRAY
-- *************************************************************************
function UpdateGrid()


	local LastSet=MultiRaidAlertOptions["LastSet"]
	local buttons=table.getn(MultiRaidAlertData[LastSet]["MSG"])

	Height=35
	if MultiRaidAlertData[LastSet] then
		--MultiRaidAlertLabel:SetText(MultiRaidAlertData[LastSet]["NAME"].." ("..LastSet.."/"..table.getn(MultiRaidAlertData)..")")
		MultiRaidAlertLabel:SetText(MultiRaidAlertData[LastSet]["NAME"])
		--config used buttons
		for button=1, table.getn(MultiRaidAlertData[LastSet]["MSG"]) do
			getglobal("MRABut"..button):Show()
			getglobal("MRABut"..button):SetText(MultiRaidAlertData[LastSet]["MSG"][button][1])

			if MultiRaidAlertData[LastSet]["MSG"][button][1]~="" then


				--position buttons
				getglobal("MRABut"..button):ClearAllPoints()

				if button==3 or button==6 then
					getglobal("MRABut"..button):SetPoint("TOPRIGHT" , "MultiRaidAlertFrame" , "TOPRIGHT" , -8, -(Height-10)) 
				elseif button==5 then
				      	getglobal("MRABut"..button):SetPoint("TOPLEFT" , "MultiRaidAlertFrame" , "TOPLEFT" ,38, -(Height-10)) 
				else
					getglobal("MRABut"..button):SetPoint("TOPLEFT" , "MultiRaidAlertFrame" , "TOPLEFT" , 8, -(Height-10)) 
				end


				--skip spacing for multiple buttons on 1 line (hardcoded)
				if (button ~=2) and (button ~=4) and (button ~=5) then 
					Height=Height+MRA_ButtonSpacing 
					
					if MultiRaidAlertData[LastSet]["MSG"][button][3] then
						Height=Height+MRA_ButtonSpacer
					end
				end
			else
				getglobal("MRABut"..button):Hide()
			end


		end
		--and hide others
		for button=buttons+1,MRAMAX_BUTTONS do
			getglobal("MRABut"..button):Hide()	
		end
	end	

	if (buttons ==2) or (buttons ==4) or (buttons ==4) then 
		Height=Height+MRA_ButtonSpacing 
	end
	
	MultiRaidAlertFrame:SetHeight(Height)
end

-- *************************************************************************
-- MOUSEWHEEL EVENT (switch sets)
-- ************************************************************************
function MultiRaidAlert_MouseWheel(arg1)

	local LastSet

	if IsShiftKeyDown() then 

		LastSet=MultiRaidAlertOptions["LastSet"]

		if (arg1==-1) then
			LastSet=LastSet+1
			if not(MultiRaidAlertData[LastSet]) then
				LastSet=1
			end
		end

	
		if (arg1==1) then
			LastSet=LastSet-1
	
			if (LastSet==0) then 
				LastSet=table.getn(MultiRaidAlertData)
			end
		end
	
		MultiRaidAlertOptions["LastSet"]=LastSet

		UpdateGrid()
		--MRAPrintout("New command set is now: "..MultiRaidAlertOptions["LastSet"].." ["..MultiRaidAlertData[MultiRaidAlertOptions["LastSet"]]["NAME"].."]")

		if MultiRaidAlertFrame:IsVisible() then
			UpdateConfigGrid()
		end
	end

end


-- *************************************************************************
-- COMMAND LINE PARAMETER HANDLER
-- *************************************************************************
function MultiRaidAlert_cmd(msg)

	if msg=="toggle" or msg=="" then
		if MultiRaidAlertFrame:IsVisible() then
			MultiRaidAlertFrame:Hide()
			MultiRaidAlertOptions["Visible"]=false
		else
			MultiRaidAlertFrame:Show()
			MultiRaidAlertOptions["Visible"]=true
		end
	end

	if msg=="config" then
		MultiRaidAlertConfigFrame:Show()

		MRAPrintout("Multi Raid Alert config panel is now VISIBLE")	
		UpdateConfigGrid()
	end

	if msg=="reset" then
		ResetVars()
	end

end

-- *************************************************************************
-- VARIABLE FIRST-TIME INIT
-- *************************************************************************
function InitVars()

	if not(MultiRaidAlertData) or not(MultiRaidAlertOptions) then
		MRAPrintout("Data not found")
		ResetVars()
	end

end

function ResetVars()

	MRAPrintout("Reverting to dummy default set")








MultiRaidAlertData = {
	[1] = {
		["NAME"] = "Molten Core",
		["MSG"] = {
			[1] = {
				[1] = "PULL",
				[2] = "Pull when ready",
				[3] = 1,
				[4] = "CTRAID",
				[5] = "0",
			},
			[2] = {
				[1] = "START",
				[2] = "Start attack",
				[4] = "CTRAID",
				[5] = "0",
			},
			[3] = {
				[1] = "STOP",
				[2] = "Stop Attack!",
				[3] = 1,
				[4] = "CTRAID",
				[5] = "0",
			},
			[4] = {
				[1] = "MT1",
				[2] = "Assist MT1",
				[4] = "CTRAID",
				[5] = "0",
			},
			[5] = {
				[1] = "MT2",
				[2] = "Assist MT2",
				[4] = "CTRAID",
				[5] = "0",
			},
			[6] = {
				[1] = "MT3",
				[2] = "Assist MT3",
				[3] = 1,
				[4] = "CTRAID",
				[5] = "0",
			},
			[7] = {
				[1] = "SKIN DOG",
				[2] = "Loot dog pls",
				[3] = 1,
				[4] = "CTRAID",
				[5] = "0",
			},
			[8] = {
				[1] = "SPAWN",
				[2] = "Kill lavaspawn!",
				[4] = "CTRAID",
				[5] = "0",
			},
			[9] = {
				[1] = "BANISH",
				[2] = "Banish!!",
				[4] = "CTRAID",
				[5] = "0",
			},
			[10] = {
				[1] = "ADD",
				[2] = "Add incoming === Tanks pick it up",
				[4] = "CTRAID",
				[5] = "0",
			},
		},
		["LEFTBRACKETS"] = "===",
		["RIGHTBRACKETS"] = "===",
	},
	[2] = {
		["NAME"] = "Zul'Gurub",
		["MSG"] = {
			[1] = {
				[1] = "PULL",
				[2] = "Pull then ready",
				[3] = 1,
				[4] = "CTRAID",
				[5] = "0",
			},
			[2] = {
				[1] = "START",
				[2] = "Start attack!",
				[4] = "CTRAID",
				[5] = "0",
			},
			[3] = {
				[1] = "STOP",
				[2] = "Stop attack!",
				[3] = 1,
				[4] = "CTRAID",
				[5] = "0",
			},
			[4] = {
				[1] = "MT1",
				[2] = "Assist MT1",
				[4] = "CTRAID",
				[5] = "0",
			},
			[5] = {
				[1] = "MT2",
				[2] = "Assist MT2",
				[4] = "CTRAID",
				[5] = "0",
			},
			[6] = {
				[1] = "MT3",
				[2] = "Assist MT3",
				[3] = 1,
				[4] = "CTRAID",
				[5] = "0",
			},
			[7] = {
				[1] = "ZERKER",
				[2] = "Pull Berserker",
				[4] = "CTRAID",
				[5] = "0",
			},
			[8] = {
				[1] = "IMPS",
				[2] = "Imps: Kill one at a time! Tank/Banish, kill voids first",
				[4] = "CTRAID",
				[5] = "0",
			},
			[9] = {
				[1] = "BD",
				[2] = "Blood Drinker - Max range, no melee",
				[4] = "CTRAID",
				[5] = "0",
			},
			[10] = {
				[1] = "BP",
				[2] = "Blood Priest - Stunlock",
				[3] = 1,
				[4] = "CTRAID",
				[5] = "0",
			},
			[11] = {
				[1] = "POISON",
				[2] = "Get poisoned now!!",
				[4] = "CTRAID",
				[5] = "0",
			},
			[12] = {
				[1] = "SON",
				[2] = "Pull son now!",
				[4] = "CTRAID",
				[5] = "0",
			},
		},
		["LEFTBRACKETS"] = "===",
		["RIGHTBRACKETS"] = "===",
	},
	[3] = {
		["NAME"] = "Onyxia",
		["MSG"] = {
			[1] = {
				[1] = "Pull",
				[2] = "Pull when ready",
				[4] = "CTRAID",
				[5] = "0",
			},
			[2] = {
				[1] = "Start",
				[2] = "Start low DPS",
				[4] = "CTRAID",
				[5] = "0",
			},
			[3] = {
				[1] = "Stop",
				[2] = "Stop Attack!",
				[3] = 1,
				[4] = "CTRAID",
				[5] = "0",
			},
			[4] = {
				[1] = "",
				[2] = "TEXT",
				[4] = "RAID",
				[5] = "0",
			},
			[5] = {
				[1] = "",
				[2] = "TEXT",
				[4] = "RAID",
				[5] = "0",
			},
			[6] = {
				[1] = "",
				[2] = "TEXT",
				[4] = "RAID",
				[5] = "0",
			},
			[7] = {
				[1] = "DOTS",
				[2] = "Max DOTS - Max DPS",
				[4] = "CTRAID",
				[5] = "0",
			},
			[8] = {
				[1] = "NODOTS",
				[2] = "Stop DOTS",
				[4] = "CTRAID",
				[5] = "0",
			},
			[9] = {
				[1] = "WHELPS",
				[2] = "Kill whelps!",
				[4] = "CTRAID",
				[5] = "0",
			},
		},
		["LEFTBRACKETS"] = "===",
		["RIGHTBRACKETS"] = "===",
	},
}
MultiRaidAlertOptions = {
	["Visible"] = false,
	["LastSet"] = 3,
}






	UpdateGrid()
	UpdateConfigGrid()

end



-- *************************************************************************
-- stuff
-- ************************************************************************


function MRAPrintout(msg)
	DEFAULT_CHAT_FRAME:AddMessage("[MRA] "..msg, 1.0, 1.0, 0.0);
end

function MultiRaidAlert_OnDragStart()
	MultiRaidAlertFrame:StartMoving();
end

function MultiRaidAlert_OnDragStop()
	MultiRaidAlertFrame:StopMovingOrSizing()
end

function MultiRaidAlertConfig_OnDragStart()
	MultiRaidAlertConfigFrame:StartMoving();
end

function MultiRaidAlertConfig_OnDragStop()
	MultiRaidAlertConfigFrame:StopMovingOrSizing()
end
